
func rMagicObject1(var action, var object, var newVal, var *ptr)

    var sb, p1, bytes[4];

    if (action != WRITE_MAGIC_BYTES || newVal != 4) goto exit;  // check command and number of bytes

    // arrange the received bytes
    bytes[1] := ptr[0] << 8 + ptr[1];
    bytes[0] := ptr[2] << 8 + ptr[3];

    gfx_MoveTo(0,180);      // move the cursor to a specific location
    txt_FGcolour(LIME);     // set text foreground color
    print("received: ", [HEX2]ptr[0]," ",[HEX2]ptr[1]," ",[HEX2]ptr[2]," ",[HEX2]ptr[3],"    ");

    p1 := str_Ptr(bytes);

    sb := (ptr[0] && 0x0080) >> 7;  // get the sign bit

    if(!sb)   // if positive
        str_Printf(&p1, "%10ld");   // print to display, format: signed long decimal 10-digit padded with spaces
        print(" ");
    else
        str_Printf(&p1, "%010ld");  // print to display, format: signed long decimal with leading zeros
    endif

    writeToLeddigits(bytes, 1, SIGNED);

exit:
    seroutX(ACK) ;
endfunc
